unit frmClient;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, XMLWorks2,
  StdCtrls, IdTCPServer, IdHTTPServer, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses XMLWorksRPC, typinfo;//, uPositionRequest;

{$R *.DFM}



procedure TForm1.Button1Click(Sender: TObject);
var
  Request: TXMLRPCMethodCall;
  Response: TXMLRPCMethodResponse;
  Struct: TXMLRPCStruct;
  Arr: TXMLRPCArray;
  i: integer;

begin
  Request := TXMLRPCMethodCall.Create;
  try
    // Where the request sent to
    Request.URL := 'http://localhost:6060';

    // The name of the remote method
    Request.RPCMethodName := 'sum';


    // Create a struct and add it to the params
    Struct := TXMLRPCStruct.Create;
    try
      Struct.AddInteger(100).name := 'NumberTest';
      Struct.AddBase64('!@#$%').name := 'Base64Test';
      Request.Params.param.Add(Struct.XML);
    finally
      Struct.Free;
    end;

    // Create an Array and add it to the params
    Arr := TXMLRPCArray.Create;
    try
      for i := 0 to 5 do
        Arr.Data.AddInteger(i);
      Request.Params.param.Add(Arr.XML);
    finally
      Arr.Free;
    end;

    // Add the current time stamp as a parameter
    Request.Params.Param.AddDateTime(now);


    // Create a Response object, passing a Request - this makes the connection
    Response := TXMLRPCMethodResponse.Create();
    try
      Memo1.Lines.Add(Request.XML);
      Response.ProcessRequest(Request);
      if Response.IsFault then
        Memo2.Lines.Text := '**FAULT' + #13#10 + Response.XML
      else
        Memo2.Lines.Text := '**SUCCESS' + #13#10 + Response.XML;
    finally
      Response.Free;
    end;
  finally
    Request.Free;
  end;
end;


procedure TForm1.FormClick(Sender: TObject);
//var
//  s: TXMLPositionRequest;
begin
{
  S:= TXMLPositionRequest.Create;
  s.Regions.Add('10');
  s.Regions.Add('101');
  s.Locations.Add('134');
  s.Desks.Add('999');

  s.DateStart := Now;
  s.DateEnd := Now + 31;
  s.ViewType := pv_Daily;

  s.Grouping.Add('134');
  Memo1.Lines.Text := s.xml;
  s.free;
 }
end;


end.
