unit xmlWorksMiniTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, xmlworks2,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button3: TButton;
    XMLMemo: TMemo;
    debug: TMemo;
    Button4: TButton;
    Label1: TLabel;
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

  ITest = interface (IUnknown)
    procedure doIt;
  end;

  TXMLIntfTest = class (TXMLInterfacedObject, IXMLWorksObject,ITest)
  private
    FString : string;
  protected
    procedure doIt;
  published
    property aString : string read FString write FString;
  end;

  TXMLTest = class(TXMLObject)
  private
    FVarString : variant;
    FVarnull : variant;
    FVarUnassigned : variant;
    FVarInteger : variant;
    FVarBoolean : variant;
    FVarInterface : variant;
    FVarArray : variant;
    FInterface : IUnknown;
  published
    property propVarString : variant read FVarString write FVarString;
    property propVarUnassigned : variant read FVarUnassigned write FVarUnassigned;
    property propVarNull : variant read FVarnull write FVarnull;
    property propVarInteger : variant read FVarInteger write FVarInteger;
    property propVarBoolean : variant read FVarBoolean write FVarBoolean;
    property propVarInterface : variant read FVarInterface write FVarInterface;
    property propVarArray : variant read FVarArray write FVarArray;
    property propInterface : IUnknown read FInterface write FInterface;
  end;
var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button3Click(Sender: TObject);
var
  xmlObj : TXMLTest;
  xmlIntfObj : TXMLIntfTest;
  intf : IXMLWorksObject;
  v : variant;
begin
  xmlIntfObj := TXMLIntfTest.create;
  xmlIntfObj.aString := 'und noch ein string';
  intf :=  xmlIntfObj;
  xmlObj := TXMLTest.create;
  xmlObj.propVarNull := null;
  xmlObj.propVarString := 'ein string';
  xmlObj.propVarBoolean := false;
  xmlObj.propVarInteger := 123456;
  xmlObj.propVarInterface := intf;
  xmlObj.propInterface := intf;
  v := VarArrayCreate([1,2,1,2,1,2,1,2],varVariant);
  v[1,2,1,2] := 'arrayTest';
  xmlObj.propVarArray := v;
  XMLMemo.Lines.Text := xmlObj.XML;
  xmlObj.Free;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  xmlObj : TXMLTest;
  xmlIntfObj : TXMLIntfTest;
  intf,intf2 : IXMLWorksObject;
  unk : IUnknown;
  a,b,c,d : Integer;
begin
  xmlObj := TXMLTest.create;
  xmlIntfObj := TXMLIntfTest.create;
  intf :=  xmlIntfObj;
  xmlObj.propVarInterface := intf;
  xmlObj.propInterface := intf;
  debug.Lines.Clear;
  xmlObj.XML := XMLMemo.lines.text;
  debug.Lines.Add('xmlObj.propVarString Typ: '+IntToStr(VarType(xmlObj.propVarString)));
  debug.Lines.Add('xmlObj.propVarString Data: '+xmlObj.propVarString);
  debug.Lines.Add('xmlObj.propVarBoolean Typ: '+IntToStr(VarType(xmlObj.propVarBoolean)));
  if xmlObj.propVarBoolean = true then
    debug.Lines.Add('xmlObj.propVarBoolean Data: true')
  else
    debug.Lines.Add('xmlObj.propVarBoolean Data: false');
  debug.Lines.Add('xmlObj.propVarInteger Typ: '+IntToStr(VarType(xmlObj.propVarInteger)));
  debug.Lines.Add('xmlObj.propVarInteger Data: '+IntToStr(xmlObj.propVarInteger));
  if xmlObj.propVarNull = null then
    debug.Lines.Add('xmlObj.propVarNull OK')
  else
    debug.Lines.Add('xmlObj.propVarNull Failed');
  if VarType(xmlObj.propVarUnassigned) = varEmpty then
    debug.Lines.Add('xmlObj.propVarUnassigned OK')
  else
    debug.Lines.Add('xmlObj.propVarUnassigned Failed');
  if VarType(xmlObj.propVarInterface) = varEmpty then
    debug.Lines.Add('xmlObj.propVarInterface Failed')
  else begin
    unk := IUnknown(xmlObj.propVarInterface);
    unk.QueryInterface(IxmlWorksObject,intf2);
    if assigned(Intf2) then
      debug.Lines.Add('xmlObj.propVarInterface Assigned XML : '+intf2.xml)
    else
      debug.Lines.Add('xmlObj.propVarInterface Assigned but Interface not found');
  end;
  if xmlObj.propInterface = nil then
    debug.Lines.Add('xmlObj.propInterface Failed')
  else begin
    unk := xmlObj.propInterface;
    unk.QueryInterface(IxmlWorksObject,intf2);
    if assigned(Intf2) then
      debug.Lines.Add('xmlObj.propInterface Assigned XML : '+intf2.xml)
    else
      debug.Lines.Add('xmlObj.propInterface Assigned but Interface not found');
  end;
  for a := 1 to 2 do begin
    for b := 1 to 2 do begin
      for c := 1 to 2 do begin
        for d := 1 to 2 do begin
          debug.Lines.Add('xmlObj.propVarInteger['+InttoStr(a)+','+InttoStr(b)+','+InttoStr(c)+','+InttoStr(d)+'] Typ: '+IntToStr(VarType(xmlObj.propVarArray[a,b,c,d])));
          debug.Lines.Add('xmlObj.propVarInteger['+InttoStr(a)+','+InttoStr(b)+','+InttoStr(c)+','+InttoStr(d)+'] Data: '+VarToStr(xmlObj.propVarArray[a,b,c,d]));
        end;
      end;
    end;
  end;
  xmlObj.Free;
end;

procedure TXMLIntfTest.doIt;
begin
  showMessage('done');
end;

end.
